<template>
  <q-page class="row justify-center content-start bg-blue-grey-1 q-pa-xl">
    <div class="row justify-between col-12 q-pb-lg">
      <div
        class="text-h4 text-bold text-primary self-end"
        v-text="'Temas'"
      />

      <q-btn
        class="super-rounded-borders"
        style="width: 272px"
        label="Novo Tema"
        color="primary"
        padding="14px"
        @click="edit()"
      />
    </div>

    <table-view
      class="col-12"
      :columns="columns"
      :table-data="tableData"
      sort-by="id"
      @reload="asyncReload('tableData')"
    />
  </q-page>
</template>

<script>
import TableView from 'components/topic/table-view'
import FormTopic from 'components/topic/form-topic'

const formFactory = JSON.stringify({
  name: '',
  material: '',
  image: ''
})

export default {
  name: 'PageTopics',
  components: { TableView },
  asyncData: {
    tableDataDefault: [],
    async tableData () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Topics'
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  data () {
    return {
      columns: [
        { name: 'id', field: 'id', label: '#', align: 'left', sortable: true },
        { name: 'name', field: 'name', label: 'Nome', align: 'left', sortable: true },
        { name: 'material', field: 'material', label: 'Material de Apoio', align: 'center', sortable: true },
        { name: 'image', field: 'image', label: 'Imagem', align: 'center' },
        { name: 'action', field: 'action', label: 'Ações', align: 'center' }
      ]
    }
  },
  methods: {
    edit (row = JSON.parse(formFactory)) {
      this.$q.dialog({
        component: FormTopic,
        value: Object.assign({}, row),
        parent: this
      }).onOk(() => {
        this.asyncReload('tableData')
      })
    }
  }
}
</script>
